# Changelog

All notable changes to this project will be documented in this file.

# [1.0.0] - 2025-03-01

### Added

- Introduction of new asynchronous engine methods `execute()` and `resume()` which replace the old synchronous methods such as `start()` and `resume_async()`.
- New examples and documentation updates demonstrating how to run workflows using asyncio (e.g., using `asyncio.run(...)`).
- Enhanced checkpoint persistence with improved saving and loading of engine state.

### Changed

- Refactored engine internals for better handling of parallel execution, flow control, and convergence points.
- Updated ChainStatus to be a string (for enhanced debugging clarity).
- Updated state management and buffer validation error messages.

### Fixed

- Addressed issues with buffer type validation and provided clearer error messages.
- Fixed several issues in the engine related to node routing and cyclical workflows.

---

# [0.2.6] - 2025-02-02

### Added

- N/A

### Changed

- N/A

### Fixed

- Changed ChainStatus enum to be a string instead of an integer so it's easier to debug.

# [0.2.5] - 2025-02-02

### Added

- N/A

### Changed

- N/A

### Fixed

- Fixed base.py on \_analyze_router_paths method that was not checking if the router node has any possible routes.

# [0.2.4] - 2025-02-02

### Added

- N/A

### Changed

- N/A

### Fixed

- Fixed base.py build_path when working with cyclical graphs.

# [0.2.3] - 2025-01-23

### Added

- N/A

### Changed

- N/A

### Fixed

- Fixed variable cleaning on resume_async method that was making it get stuck.

# [0.2.2] - 2025-01-23

### Added

- N/A

### Changed

- N/A

### Fixed

- Fixed the `END` node not flagging the chain as done.
- Added better error messages for buffer type validation.

# [0.2.1] - 2025-01-14

### Added

- N/A

### Changed

- N/A

### Fixed

- Added ChainStatus.DONE when END node is reached as before it was not flagging the chain as done.

## [0.2.0] - 2025-01-09

### Added

- Added `set_state_and_checkpoint` method to `Graph` class.
- Added `update_state_and_checkpoint` method to `Graph` class.

### Changed

- N/A

### Fixed

- N/A
